/*------------------------------------------------------------
TEAM13
A
179
Target: LegionMSVC7; Platform: Win32; Comment: MS Visual C++ 7 (Legionaries)
------------------------------------------------------------*/
#define _CRT_SECURE_NO_DEPRECATE

#include <stdio.h>

void prepare( )
{
//	freopen( "in.txt", "r", stdin );
}

#include <assert.h>
#include <string.h>
#include <math.h>
#include <algorithm>
#include <functional>
#include <vector>
#include <string>
#include <deque>
#include <map>
#include <set>
#include <time.h>

#define fo( a, b, c ) for( a = ( b ); a < ( c ); ++ a )
#define fr( a, b ) fo( a, 0, ( b ) )
#define fi( a ) fr( i, ( a ) )
#define fj( a ) fr( j, ( a ) )
#define fk( a ) fr( k, ( a ) )
#define fij( a ) fo( j, i + 1, ( a ) )
#define fin fi( n )
#define MAXN 20
#define MAXQ 405

using namespace std;

int n;

char mp[MAXN][MAXN];
char iso[MAXN][MAXN];
short plr[MAXN][MAXN];

int we, enemy;
char ask_name;

int sx[2], sy[2];

int qx[MAXQ];
int qy[MAXQ];
int qf[MAXQ];
int qn;
char p[MAXN][MAXN];
char pp[MAXN][MAXN];

int zu = 0;

int moo_left = 5;

void readdata( )
{
	int i, j;

	srand( time( 0 ) );

	if( scanf( "%d", &we ) == EOF )
	{
		ask_name = 1;
		return;
	}
	enemy = 1 - we;

	scanf( "%d", &n );
	scanf( "%d %d", &sy[0], &sx[0] );
	scanf( "%d %d", &sy[1], &sx[1] );

	char s[7];
	for( i = 0; i < n; ++ i )
		for( j = 0; j < n; ++ j )
		{
			scanf( "%s", &s );
			if( s[0] == '.' )
			{
				mp[i][j] = 0;
				continue;
			}
			if( s[0] == 'v' || s[0] == 'n' )
			{
				s[0] = s[0] - 'a' + 'A';
				iso[i][j] = 1;
			}
			mp[i][j] = s[0];
			plr[i][j] = s[1] - '0';
			if( plr[i][j] != we )
				enemy = plr[i][j];
			else ++ zu;
		}
}

char is_we( int x, int y )
{
	if( x < 0 || y < 0 || x >= n || y >= n ) return 0;

	if( plr[x][y] == we && mp[x][y] && !iso[x][y] )
		return 1;

	return 0;
}

char is_enemy( int x, int y )
{
	if( x < 0 || y < 0 || x >= n || y >= n ) return 0;

	if( plr[x][y] == enemy && mp[x][y] )
		return 1;

	return 0;
}

int num_adjanced_enemy( int x, int y )
{
	int res = 0;

	if( is_enemy( x + 1, y ) ) ++ res;
	if( is_enemy( x - 1, y ) ) ++ res;
	if( is_enemy( x, y + 1 ) ) ++ res;
	if( is_enemy( x, y - 1 ) ) ++ res;

	return res;
}

char adjanced_we( int x, int y )
{
	if( is_we( x - 1, y ) ) return 1;
	if( is_we( x + 1, y ) ) return 1;
	if( is_we( x, y - 1 ) ) return 1;
	if( is_we( x, y + 1 ) ) return 1;

	return 0;
}

char adjanced_enemy( int x, int y )
{
	if( is_enemy( x - 1, y ) ) return 1;
	if( is_enemy( x + 1, y ) ) return 1;
	if( is_enemy( x, y - 1 ) ) return 1;
	if( is_enemy( x, y + 1 ) ) return 1;

	return 0;
}

char good_droch( int x, int y, int & qx, int & qy )
{
	if( adjanced_we( x, y ) )
	{
		qx = x;
		qy = y;
		return 1;
	}
	if( adjanced_we( x - 1, y ) )
	{
		qx = x - 1;
		qy = y;
		return 1;
	}
	if( adjanced_we( x + 1, y ) )
	{
		qx = x + 1;
		qy = y;
		return 1;
	}
	if( adjanced_we( x, y - 1 ) )
	{
		qx = x;
		qy = y - 1;
		return 1;
	}
	if( adjanced_we( x, y + 1 ) )
	{
		qx = x;
		qy = y + 1;
		return 1;
	}

	return 0;
}

char good_droch_to_us( int x, int y )
{
	if( adjanced_enemy( x - 1, y ) ) return 1;
	if( adjanced_enemy( x + 1, y ) ) return 1;
	if( adjanced_enemy( x, y - 1 ) ) return 1;
	if( adjanced_enemy( x, y + 1 ) ) return 1;

	return 0;
}

void dfs( int x, int y )
{
	if( x < 0 || y < 0 || x >= n || y >= n )
		return;

	if( pp[x][y] ) return;
	pp[x][y] = 1;

	if( !mp[x][y] || plr[x][y] == enemy ) return;
	iso[x][y] = 0;

	dfs( x - 1, y );
	dfs( x + 1, y );
	dfs( x, y - 1 );
	dfs( x, y + 1 );
}

char make_turn( int x, int y )
{
	int moo;
	if( !mp[x][y] ) moo = 1;
	else if( plr[x][y] == we ) return 0;
	else if( mp[x][y] == 'V' ) moo = 3;
	else moo = 2;

	if( moo_left < moo ) return 0;

	plr[x][y] = we;
	if( moo > 1 ) mp[x][y] = 'V';
	else mp[x][y] = 'N';

	moo_left -= moo;
	printf( "%li %li %li\n", y, x, moo );

	memset( pp, 0, sizeof( pp ) );
	dfs( x, y );

	return 1;
}

int make_x( int a )
{
	if( sx[we] == 0 ) return a;
	return n - a - 1;
}

void add3( int x, int y, int f )
{
	if( x < 0 || y < 0 || x >= n || y >= n )
		return;

	if( p[x][y] ) return;
	p[x][y] = 1;

	qx[qn] = x;
	qy[qn] = y;
	qf[qn] = f;
	++ qn;
}

int dst_to_enemy( int x, int y )
{
	int i;

	memset( p, 0, sizeof( p ) );
	qn = 0;

	add3( x, y, 0 );
	for( i = 0; i < qn; ++ i )
	{
		if( mp[qx[i]][qy[i]] && plr[qx[i]][qy[i]] == enemy )
			return qf[i];

		add3( qx[i] - 1, qy[i], qf[i] + 1 );
		add3( qx[i] + 1, qy[i], qf[i] + 1 );
		add3( qx[i], qy[i] - 1, qf[i] + 1 );
		add3( qx[i], qy[i] + 1, qf[i] + 1 );
	}

	return 0;
}

void find_kletka_that_will_not_be_drochen( int & a, int & b )
{
	int i, j;
	int dst, ndst;
	vector< pair< int, int > > v;

	a = -1;
	b = -1;

		for( i = 0; i < n; ++ i )
			for( j = 0; j < n; ++ j )
			{
				if( adjanced_we( i, j ) && !mp[i][j] && !good_droch_to_us( i, j ) )
				{
					ndst = abs( i - sx[we] ) + abs( j - sy[we] );
					if( a == -1 || dst > ndst || ( dst == ndst && rand( ) % 4 == 0 ) )
					{
						a = i;
						b = j;
						dst = ndst;
					}
				}
			}
}

void add( int x, int y, int f )
{
	if( x < 0 || y < 0 || x >= n || y >= n ) return;
	if( mp[x][y] && ( plr[x][y] == enemy || ( plr[x][y] == we && mp[x][y] == 'V' ) ) )
	{
		if( p[x][y] ) return;
		p[x][y] = 1;

		qx[qn] = x;
		qy[qn] = y;
		qf[qn] = f;
		++ qn;
	}
}

void add2( int x, int y )
{
	if( x < 0 || y < 0 || x >= n || y >= n ) return;
	if( mp[x][y] && plr[x][y] == we )
	{
		if( p[x][y] ) return;
		p[x][y] = 1;

		qx[qn] = x;
		qy[qn] = y;
		++ qn;
	}
}

void find_our_veteran( int & x, int & y, int & dx, int & dy )
{
	int i;

	qn = 0;
	memset( p, 0, sizeof( p ) );

	add( sx[enemy], sy[enemy], -1 );

	for( i = 0; i < qn; ++ i )
	{
		if( plr[qx[i]][qy[i]] == we && mp[qx[i]][qy[i]] == 'V' )
		{
			x = qx[i];
			y = qy[i];
			if( qf[i] == -1 )
			{
				qf[i] = 0;
			}
			dx = qx[qf[i]];
			dy = qy[qf[i]];

			return;
		}

		add( qx[i] - 1, qy[i], i );
		add( qx[i] + 1, qy[i], i );
		add( qx[i], qy[i] - 1, i );
		add( qx[i], qy[i] + 1, i );
	}

	x = -1;
	y = -1;
}

void find_anal_place( int x, int y, int & rx, int & ry )
{
	int i;

	qn = 0;
	memset( p, 0, sizeof( p ) );

	add( x, y, -1 );

	for( i = 0; i < qn; ++ i )
	{
		if( plr[qx[i]][qy[i]] == enemy && adjanced_we( qx[i], qy[i] ) )
		{
			rx = qx[i];
			ry = qy[i];
			
			return;
		}

		if( plr[qx[i]][qy[i]] != enemy )
		{
			add( qx[i] - 1, qy[i], i );
			add( qx[i] + 1, qy[i], i );
			add( qx[i], qy[i] - 1, i );
			add( qx[i], qy[i] + 1, i );
		}
	}

	x = -1;
	y = -1;
}

void try_to_be_mirnyj_osel( )
{
	int drx, dry;

	while( moo_left )
	{
		find_kletka_that_will_not_be_drochen( drx, dry );
		if( drx == -1 ) //  ,        -    
			break;

		if( !make_turn( drx, dry ) )
			break;
	}
}

void find_opponent_to_droch( int & rx, int & ry, int & mx, int & my )
{
	int i, j;
	int qx, qy;
	int dst, ndst;

	rx = -1;
	ry = -1;
	dst = -1;

	for( i = 0; i < n; ++ i )
		for( j = 0; j < n; ++ j )
		{
			if( plr[i][j] == enemy && mp[i][j] && good_droch( i, j, qx, qy ) )
			{
				ndst = abs( i - sx[enemy] ) + abs( j - sy[enemy] );
				if( rx == -1 || dst < ndst )
				{
					rx = i;
					ry = j;
					mx = qx;
					my = qy;
					dst = ndst;
				}
			}
		}
}

void find_opponent_zagovorcheg( int mx, int my, int & x, int & y )
{
	int i;

	x = -1;
	y = -1;

	memset( p, 0, sizeof( p ) );

	qn = 0;

	add2( mx, my );

	for( i = 0; i < qn; ++ i )
	{
		if( mp[qx[i]][qy[i]] == 'N' )
		{
			if( is_enemy( qx[i] + 1, qy[i] ) )
			{
				x = qx[i] + 1;
				y = qy[i];
				return;
			}
			if( is_enemy( qx[i] - 1, qy[i] ) )
			{
				x = qx[i] - 1;
				y = qy[i];
				return;
			}
			if( is_enemy( qx[i], qy[i] + 1 ) )
			{
				x = qx[i];
				y = qy[i] + 1;
				return;
			}
			if( is_enemy( qx[i], qy[i] - 1 ) )
			{
				x = qx[i];
				y = qy[i] - 1;
				return;
			}
		}
		else
		{
			add2( qx[i] - 1, qy[i] );
			add2( qx[i] + 1, qy[i] );
			add2( qx[i], qy[i] - 1 );
			add2( qx[i], qy[i] + 1 );
		}
	}
}

void solve( )
{
	int ovx, ovy;
	int drx, dry;
	int mox, moy;
	int i, j;
	int a, b;
	vector< pair< int, int > > v;

	if( ask_name == 1 ) return;


	find_our_veteran( ovx, ovy, drx, dry );
	fprintf( stderr, "%d %d\n", ovx, ovy );

	if( ovx == -1 ) //     
	{
		fprintf( stderr, "No moo\n" );
		find_opponent_to_droch( drx, dry, mox, moy );
		if( drx == -1 ) //      -  
		{
			fprintf( stderr, "No moo moo\n" );
/*			find_opponent_to_droch_clever( drx, dry, mox, moy );
			if( drx == -1 ) //         -   
			{ */ //    ,    
				try_to_be_mirnyj_osel( );
/*			}
			else
			{

			} */
		}
		else
		{
			fprintf( stderr, "Moo moo\n" );
			make_turn( mox, moy );
			make_turn( drx, dry );
		}
	}

	find_our_veteran( ovx, ovy, drx, dry );
	if( ovx != -1 ) //   
	{
		fprintf( stderr, "Moo\n" );
		while( 1 )
		{
			find_our_veteran( ovx, ovy, drx, dry );
			if( !iso[ovx][ovy] ) //         (      )
			{
				//          
				find_opponent_zagovorcheg( ovx, ovy, drx, dry );
				if( drx != -1 )
				{
					if( !make_turn( drx, dry ) )
						break;
				}
				else
				{
					while( 1 )
					{
						find_our_veteran( ovx, ovy, drx, dry );
						if( !make_turn( drx, dry ) ) break;
					}
					try_to_be_mirnyj_osel( );
				}
				break;
			}
			else // 
			{
				find_anal_place( ovx, ovy, drx, dry );
				if( drx == -1 ) break;
				if( !make_turn( drx, dry ) )
					break;
			}
		}
	}
	try_to_be_mirnyj_osel( );
}

void writedata( )
{
	if( ask_name == 1 )
	{
		printf( "Imba Moo-o-oo!!!\n" );
		return;
	}
}

int main( )
{
	prepare( );

	readdata( );
	solve( );
	writedata( );

	return 0;
}
