/*------------------------------------------------------------
TEAM16
A
152
Target: LegionMSVC7; Platform: Win32; Comment: MS Visual C++ 7 (Legionaries)
------------------------------------------------------------*/

#include <stdio.h>
#include <memory.h>
#include <math.h>

//const char *NAME = "Commandante Che (determined version)";
const char *NAME = "CommandanteChe";

// Viva Fidel! Viva la Cuba libra!
// La libertad o el muerte

int dx[4] = {-1,  0, 1, 0};
int dy[4] = { 0, -1, 0, 1};

int m, N;
char a[50][50]; // map
int X[2], Y[2];
int nonempty = 0;
char pf[50][50];
char g[50][50];

int cc;
int x[1000], y[1000];
int d[50][50];
int rest = 5;

struct XX
{
	int x, y, c;
};
XX ans[10];
int ansc = 0;

inline int Dist(int x1, int y1, int x2, int y2)
{
	return abs(x1 - x2) + abs(y1 - y2);
}

inline void Log(char *s)
{
	fprintf(stderr, "%s\n", s);
}
inline void Swap(int &x, int &y)
{
	int buff = x;
	x = y;
	y = buff;
}

void AddC(int i, int j)
{
	if(g[i][j] != 1)
		return;
	for(int k = 0;k < 4;k++)
	{
		int xx = i + dx[k];
		int yy = j + dy[k];
		if(!(a[xx][yy]&1) && !g[xx][yy])
		{
			pf[xx][yy] = 1;
			g[xx][yy] = 2;
			x[cc] = xx;
			y[cc++] = yy;
		}
	}
	
}

bool K(int xx, int yy)
{
	int vet = !!(a[xx][yy]&2);
	if( rest == 2 && vet )
		return 0;
	ans[ansc].x = xx;
	ans[ansc].y = yy;
	ans[ansc].c = 2 + vet;
	ansc++;
	rest -= 2 + vet;
	g[xx][yy] = 1;
	AddC(xx, yy);
	return 1;
}

void Defend()
{
	int i, j;
	if(rest < 2)
		return;

	for(int dst = 1;dst <= 8;dst++)
	{
		for(i = 1;i <= N;i++)
			for(j = 1;j <= N;j++)
			{
				if(dst == 2 && i == 4 && j == 4)
					i = i;
				if(!a[i][j] || d[i][j] != dst || g[i][j] != 2 || (a[i][j]&1))
					continue;
				if(K(i, j))
					return;
			}
	}

}

int main()
{
	if (scanf("%d %d", &m, &N) == EOF)
	{
		printf(NAME);
		return 0;
	}

	memset(a, 0, sizeof(a));
	memset(g, 0, sizeof(g));
	memset(pf, 0, sizeof(pf));

	scanf("%d %d", &X[0], &Y[0]);
	scanf("%d %d", &X[1], &Y[1]);

	X[0]++; X[1]++; Y[0]++; Y[1]++;
	if(m)
	{
		Swap(X[0], X[1]);
		Swap(Y[0], Y[1]);
	}

	int i, j;

	// border
	for(i = 0;i <= N + 1;i++)
		a[i][0] = a[i][N + 1] = a[0][i] = a[N + 1][i] = -1;

	for(i = 1;i <= N;i++)
		for(j = 1;j <= N;j++)
			d[i][j] = Dist(i, j, X[0], Y[0]);

	
	for(i = 1;i <= N;i++)
		for(j = 1;j <= N;j++)
		{
			char buff[100];
			scanf("%s", buff);
			if(buff[0] == '.')
			{
				a[j][i] = 0;
				continue;
			}
			a[j][i] = 4;
			
			if(buff[0] == 'V' || buff[0] == 'v')
			{
				a[j][i] |= 2;
			}
			if(buff[1] == '0' + m)
			{
				a[j][i] |= 1;
				if(buff[0] == 'V' || buff[0] == 'N')
				{
					g[j][i] = 1;
				}
			}
		}

	for(i = 1;i <= N;i++)
		for(j = 1;j <= N;j++)
		{
			if(a[i][j])
				nonempty++;
		}
	
	cc = 0;
	if(X[0] == 1 && Y[0] == 1)
	{
		for(j = N;j;j--)
			for(i = N;i;i--)
			{
				AddC(i, j);
			}
	}
	else
	{
		for(i = 1;i <= N;i++)
			for(j = 1;j <= N;j++)
			{
				AddC(i, j);
			}
	}

	Defend();
	Defend();

	for(i = 0;i < cc;i++)
	{
		if(!rest)
			break;
		int xx = x[i];
		int yy = y[i];
		if(!a[xx][yy])
		{
			ans[ansc].x = xx;
			ans[ansc].y = yy;
			ans[ansc].c = 1;
			ansc++;
			rest--;
			g[xx][yy] = 1;
			AddC(xx, yy);
			Defend();
			Defend();
		}
		else if( rest > 1 && !(a[xx][yy]&1) )
		{
			K(xx, yy);
		}
	}

	for(i = 0;i < ansc;i++)
	{
		printf("%d %d %d\n", ans[i].x - 1, ans[i].y - 1, ans[i].c);
	}

	return 0;
}
